/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.132 Revision 1.165
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.132 2010/02/02 22:16:04 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.165 2011/08/29 01:28:10 vapier Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 7# MySQL Team <mysql-bugs@gentoo.org>
9# - Luca Longinotti <chtekk@gentoo.org> 8# Luca Longinotti <chtekk@gentoo.org>
10# - Robin H. Johnson <robbat2@gentoo.org> 9# Robin H. Johnson <robbat2@gentoo.org>
10# @AUTHOR:
11# Francesco Riosa (Retired) <vivo@gentoo.org>
11# @BLURB: This eclass provides most of the functions for mysql ebuilds 12# @BLURB: This eclass provides most of the functions for mysql ebuilds
12# @DESCRIPTION: 13# @DESCRIPTION:
13# The mysql.eclass provides almost all the code to build the mysql ebuilds 14# The mysql.eclass provides almost all the code to build the mysql ebuilds
14# including the src_unpack, src_prepare, src_configure, src_compile, 15# including the src_unpack, src_prepare, src_configure, src_compile,
15# scr_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm 16# scr_install, pkg_preinst, pkg_postinst, pkg_config and pkg_postrm
51 ;; 52 ;;
52 *) 53 *)
53 die "Unsupported EAPI: ${EAPI}" ;; 54 die "Unsupported EAPI: ${EAPI}" ;;
54esac 55esac
55 56
57
58# @ECLASS-VARIABLE: MYSQL_PV_MAJOR
59# @DESCRIPTION:
60# Upstream MySQL considers the first two parts of the version number to be the
61# major version. Upgrades that change major version should always run
62# mysql_upgrade.
63MYSQL_PV_MAJOR="$(get_version_component_range 1-2 ${PV})"
64
65# Cluster is a special case...
66if [[ "${PN}" == "mysql-cluster" ]]; then
67 case $PV in
68 6.1*|7.0*|7.1*) MYSQL_PV_MAJOR=5.1 ;;
69 esac
70fi
71
72
56# @ECLASS-VARIABLE: MYSQL_VERSION_ID 73# @ECLASS-VARIABLE: MYSQL_VERSION_ID
57# @DESCRIPTION: 74# @DESCRIPTION:
58# MYSQL_VERSION_ID will be: 75# MYSQL_VERSION_ID will be:
59# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 76# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
60# This is an important part, because many of the choices the MySQL ebuild will do 77# This is an important part, because many of the choices the MySQL ebuild will do
77# @DESCRIPTION: 94# @DESCRIPTION:
78# Specifiy if community features are available. Possible values are 1 (yes) 95# Specifiy if community features are available. Possible values are 1 (yes)
79# and 0 (no). 96# and 0 (no).
80# Community features are available in mysql-community 97# Community features are available in mysql-community
81# AND in the re-merged mysql-5.0.82 and newer 98# AND in the re-merged mysql-5.0.82 and newer
82if [ "${PN}" == "mysql-community" ]; then 99if [ "${PN}" == "mysql-community" -o "${PN}" == "mariadb" ]; then
83 MYSQL_COMMUNITY_FEATURES=1 100 MYSQL_COMMUNITY_FEATURES=1
84elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then 101elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
85 MYSQL_COMMUNITY_FEATURES=1 102 MYSQL_COMMUNITY_FEATURES=1
86elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then 103elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
87 MYSQL_COMMUNITY_FEATURES=1 104 MYSQL_COMMUNITY_FEATURES=1
88elif [ "${PV#5.4}" != "${PV}" ] ; then 105elif [ "${PV#5.4}" != "${PV}" ] ; then
89 MYSQL_COMMUNITY_FEATURES=1 106 MYSQL_COMMUNITY_FEATURES=1
90elif [ "${PV#5.5}" != "${PV}" ] ; then 107elif [ "${PV#5.5}" != "${PV}" ] ; then
91 MYSQL_COMMUNITY_FEATURES=1 108 MYSQL_COMMUNITY_FEATURES=1
92elif [ "${PV#6.0}" != "${PV}" ] ; then 109elif [ "${PV#6}" != "${PV}" ] ; then
110 MYSQL_COMMUNITY_FEATURES=1
111elif [ "${PV#7}" != "${PV}" ] ; then
93 MYSQL_COMMUNITY_FEATURES=1 112 MYSQL_COMMUNITY_FEATURES=1
94else 113else
95 MYSQL_COMMUNITY_FEATURES=0 114 MYSQL_COMMUNITY_FEATURES=0
96fi 115fi
97 116
112 >=sys-apps/sed-4 131 >=sys-apps/sed-4
113 >=sys-apps/texinfo-4.7-r1 132 >=sys-apps/texinfo-4.7-r1
114 >=sys-libs/readline-4.1 133 >=sys-libs/readline-4.1
115 >=sys-libs/zlib-1.2.3" 134 >=sys-libs/zlib-1.2.3"
116 135
136[[ "${PN}" == "mariadb" ]] \
137&& DEPEND="${DEPEND} libevent? ( >=dev-libs/libevent-1.4 )"
138
117# Having different flavours at the same time is not a good idea 139# Having different flavours at the same time is not a good idea
118for i in "" "-community" ; do 140for i in "mysql" "mysql-community" "mysql-cluster" "mariadb" ; do
119 [[ "${i}" == ${PN#mysql} ]] || 141 [[ "${i}" == ${PN} ]] ||
120 DEPEND="${DEPEND} !dev-db/mysql${i}" 142 DEPEND="${DEPEND} !dev-db/${i}"
121done 143done
122 144
123RDEPEND="${DEPEND} 145RDEPEND="${DEPEND}
124 !minimal? ( dev-db/mysql-init-scripts ) 146 !minimal? ( dev-db/mysql-init-scripts )
125 selinux? ( sec-policy/selinux-mysql )" 147 selinux? ( sec-policy/selinux-mysql )"
126 148
149DEPEND="${DEPEND}
150 virtual/yacc"
151
152if [ "${EAPI:-0}" = "2" ]; then
153 DEPEND="${DEPEND} static? ( || ( sys-libs/ncurses[static-libs] <=sys-libs/ncurses-5.7-r3 ) )"
154fi
155
127# compile-time-only 156# compile-time-only
128mysql_version_is_at_least "5.1" \ 157mysql_version_is_at_least "5.1" \
129|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )" 158|| DEPEND="${DEPEND} berkdb? ( sys-apps/ed )"
130 159
131# compile-time-only 160# compile-time-only
132mysql_version_is_at_least "5.1.12" \ 161mysql_version_is_at_least "5.1.12" \
133&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3" 162&& DEPEND="${DEPEND} >=dev-util/cmake-2.4.3"
134 163
164[[ "${PN}" == "mariadb" ]] \
165&& mysql_version_is_at_least "5.2" \
166&& DEPEND="${DEPEND} oqgraph? ( >=dev-libs/boost-1.40.0 )"
167#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
168# sphinx? ( app-misc/sphinx )"
169
135# dev-perl/DBD-mysql is needed by some scripts installed by MySQL 170# dev-perl/DBD-mysql is needed by some scripts installed by MySQL
136PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )" 171PDEPEND="perl? ( >=dev-perl/DBD-mysql-2.9004 )"
137 172
138# For other stuff to bring us in 173# For other stuff to bring us in
139PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})" 174PDEPEND="${PDEPEND} =virtual/mysql-${MYSQL_PV_MAJOR}"
140 175
141# Work out the default SERVER_URI correctly 176# Work out the default SERVER_URI correctly
142if [ -z "${SERVER_URI}" ]; then 177if [ -z "${SERVER_URI}" ]; then
143 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}" 178 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
179 if [ "${PN}" == "mariadb" ]; then
180 MARIA_FULL_PV="$(replace_version_separator 3 '-' ${PV})"
181 MARIA_FULL_P="${PN}-${MARIA_FULL_PV}"
182 SERVER_URI="
183 http://ftp.osuosl.org/pub/mariadb/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
184 http://ftp.rediris.es/mirror/MariaDB/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
185 http://maria.llarian.net/download/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
186 http://launchpad.net/maria/${MYSQL_PV_MAJOR}/ongoing/+download/${MARIA_FULL_P}.tar.gz
187 http://mirrors.fe.up.pt/pub/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
188 http://ftp-stud.hs-esslingen.de/pub/Mirrors/${PN}/${MARIA_FULL_P}/kvm-tarbake-jaunty-x86/${MARIA_FULL_P}.tar.gz
189 "
144 # The community build is on the mirrors 190 # The community and cluster builds are on the mirrors
145 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 191 elif [[ "${MYSQL_COMMUNITY_FEATURES}" == "1" || ${PN} == "mysql-cluster" ]] ; then
146 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${MY_PV}.tar.gz" 192 if [[ "${PN}" == "mysql-cluster" ]] ; then
193 URI_DIR="MySQL-Cluster"
194 URI_FILE="mysql-cluster-gpl"
195 else
196 URI_DIR="MySQL"
197 URI_FILE="mysql"
198 fi
199 URI_A="${URI_FILE}-${MY_PV}.tar.gz"
200 MIRROR_PV=$(get_version_component_range 1-2 ${PV})
201 # Recently upstream switched to an archive site, and not on mirrors
202 SERVER_URI="http://downloads.mysql.com/archives/${URI_FILE}-${MIRROR_PV}/${URI_A}
203 mirror://mysql/Downloads/${URI_DIR}-${PV%.*}/${URI_A}"
147 # The (old) enterprise source is on the primary site only 204 # The (old) enterprise source is on the primary site only
148 elif [ "${PN}" == "mysql" ]; then 205 elif [ "${PN}" == "mysql" ]; then
149 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz" 206 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
150 fi 207 fi
151fi 208fi
158&& SRC_URI="${SRC_URI} 215&& SRC_URI="${SRC_URI}
159 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 216 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
160 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 217 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
161 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 218 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
162 219
163# PBXT engine
164mysql_version_is_at_least "5.1.12" \
165&& [[ -n "${PBXT_VERSION}" ]] \
166&& PBXT_P="pbxt-${PBXT_VERSION}" \
167&& PBXT_SRC_URI="mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
168&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )"
169
170# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
171mysql_version_is_at_least "5.1.26" \
172&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
173&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
174&& XTRADB_SRC_URI="http://www.percona.com/${PN}/xtradb/${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
175&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI} )"
176
177DESCRIPTION="A fast, multi-threaded, multi-user SQL database server." 220DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
178HOMEPAGE="http://www.mysql.com/" 221HOMEPAGE="http://www.mysql.com/"
222if [[ "${PN}" == "mariadb" ]]; then
223 HOMEPAGE="http://askmonty.org/"
224 DESCRIPTION="MariaDB is a MySQL fork with 3rd-party patches and additional storage engines merged."
225fi
226if [[ "${PN}" == "mysql-community" ]]; then
227 DESCRIPTION="${DESCRIPTION} (obsolete, move to dev-db/mysql)"
228fi
179LICENSE="GPL-2" 229LICENSE="GPL-2"
180SLOT="0" 230SLOT="0"
181IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static" 231IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
182 232
183mysql_version_is_at_least "4.1" \ 233mysql_version_is_at_least "4.1" \
184&& IUSE="${IUSE} latin1" 234&& IUSE="${IUSE} latin1"
185 235
186mysql_version_is_at_least "4.1.3" \ 236if mysql_version_is_at_least "4.1.3" ; then
187&& IUSE="${IUSE} cluster extraengine" 237 IUSE="${IUSE} extraengine"
238 if [[ "${PN}" != "mysql-cluster" ]] ; then
239 IUSE="${IUSE} cluster"
240 fi
241fi
188 242
189mysql_version_is_at_least "5.0" \ 243mysql_version_is_at_least "5.0" \
190|| IUSE="${IUSE} raid" 244|| IUSE="${IUSE} raid"
191 245
192mysql_version_is_at_least "5.0.18" \ 246mysql_version_is_at_least "5.0.18" \
193&& IUSE="${IUSE} max-idx-128" 247&& IUSE="${IUSE} max-idx-128"
194 248
195mysql_version_is_at_least "5.1" \ 249mysql_version_is_at_least "5.1" \
196|| IUSE="${IUSE} berkdb" 250|| IUSE="${IUSE} berkdb"
197 251
198mysql_version_is_at_least "5.1.12" \
199&& [[ -n "${PBXT_VERSION}" ]] \
200&& IUSE="${IUSE} pbxt"
201
202mysql_version_is_at_least "5.1.26" \
203&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
204&& IUSE="${IUSE} xtradb"
205
206[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \ 252[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
207&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling" 253&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
254
255[[ "${PN}" == "mariadb" ]] \
256&& IUSE="${IUSE} libevent"
257
258[[ "${PN}" == "mariadb" ]] \
259&& mysql_version_is_at_least "5.2" \
260&& IUSE="${IUSE} oqgraph"
261#SphinxSE is included but is not available in 5.2.4 due to a missing plug.in file
262#&& IUSE="${IUSE} oqgraph sphinx"
263
264# MariaDB has integrated PBXT
265# PBXT_VERSION means that we have a PBXT patch for this PV
266# PBXT was only introduced after 5.1.12
267pbxt_patch_available() {
268 [[ "${PN}" != "mariadb" ]] \
269 && mysql_version_is_at_least "5.1.12" \
270 && [[ -n "${PBXT_VERSION}" ]]
271 return $?
272}
273
274pbxt_available() {
275 pbxt_patch_available || [[ "${PN}" == "mariadb" ]]
276 return $?
277}
278
279# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
280# MariaDB has integrated XtraDB
281# XTRADB_VERS means that we have a XTRADB patch for this PV
282# XTRADB was only introduced after 5.1.26
283xtradb_patch_available() {
284 [[ "${PN}" != "mariadb" ]] \
285 && mysql_version_is_at_least "5.1.26" \
286 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]]
287 return $?
288}
289
290
291pbxt_patch_available \
292&& PBXT_P="pbxt-${PBXT_VERSION}" \
293&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
294&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
295
296# PBXT_NEWSTYLE means pbxt is in storage/ and gets enabled as other plugins
297# vs. built outside the dir
298pbxt_available \
299&& IUSE="${IUSE} pbxt" \
300&& mysql_version_is_at_least "5.1.40" \
301&& PBXT_NEWSTYLE=1
302
303xtradb_patch_available \
304&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
305&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
306&& XTRADB_SRC_B1="http://www.percona.com/" \
307&& XTRADB_SRC_B2="${XTRADB_SRC_B1}/percona-builds/" \
308&& XTRADB_SRC_URI1="${XTRADB_SRC_B2}/Percona-Server/Percona-Server-${XTRADB_SRC_URI_COMMON}" \
309&& XTRADB_SRC_URI2="${XTRADB_SRC_B2}/xtradb/${XTRADB_SRC_URI_COMMON}" \
310&& XTRADB_SRC_URI3="${XTRADB_SRC_B1}/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
311&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} ${XTRADB_SRC_URI3} )" \
312&& IUSE="${IUSE} xtradb"
208 313
209# 314#
210# HELPER FUNCTIONS: 315# HELPER FUNCTIONS:
211# 316#
212 317
216mysql_disable_test() { 321mysql_disable_test() {
217 local rawtestname testname testsuite reason mysql_disable_file 322 local rawtestname testname testsuite reason mysql_disable_file
218 rawtestname="${1}" ; shift 323 rawtestname="${1}" ; shift
219 reason="${@}" 324 reason="${@}"
220 ewarn "test '${rawtestname}' disabled: '${reason}'" 325 ewarn "test '${rawtestname}' disabled: '${reason}'"
221 326
222 testsuite="${rawtestname/.*}" 327 testsuite="${rawtestname/.*}"
223 testname="${rawtestname/*.}" 328 testname="${rawtestname/*.}"
224 mysql_disable_file="${S}/mysql-test/t/disabled.def" 329 mysql_disable_file="${S}/mysql-test/t/disabled.def"
225 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}" 330 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
226 echo ${testname} : ${reason} >> "${mysql_disable_file}" 331 echo ${testname} : ${reason} >> "${mysql_disable_file}"
308 MY_DATADIR="${new_MY_DATADIR}" 413 MY_DATADIR="${new_MY_DATADIR}"
309 fi 414 fi
310 fi 415 fi
311 fi 416 fi
312 417
418 if [ "${MY_SOURCEDIR:-unset}" == "unset" ]; then
313 MY_SOURCEDIR=${SERVER_URI##*/} 419 MY_SOURCEDIR=${SERVER_URI##*/}
314 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*} 420 MY_SOURCEDIR=${MY_SOURCEDIR%.tar*}
421 fi
315 422
316 export MY_SHAREDSTATEDIR MY_SYSCONFDIR 423 export MY_SHAREDSTATEDIR MY_SYSCONFDIR
317 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR 424 export MY_LIBDIR MY_LOCALSTATEDIR MY_LOGDIR
318 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR 425 export MY_INCLUDEDIR MY_DATADIR MY_SOURCEDIR
319} 426}
366 if use debug ; then 473 if use debug ; then
367 myconf="${myconf} --with-debug=full" 474 myconf="${myconf} --with-debug=full"
368 else 475 else
369 myconf="${myconf} --without-debug" 476 myconf="${myconf} --without-debug"
370 mysql_version_is_at_least "4.1.3" \ 477 mysql_version_is_at_least "4.1.3" \
371 && use cluster \ 478 && ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) \
372 && myconf="${myconf} --without-ndb-debug" 479 && myconf="${myconf} --without-ndb-debug"
373 fi 480 fi
374 481
375 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then 482 if [ -n "${MYSQL_DEFAULT_CHARSET}" -a -n "${MYSQL_DEFAULT_COLLATION}" ]; then
376 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}" 483 ewarn "You are using a custom charset of ${MYSQL_DEFAULT_CHARSET}"
400 myconf="${myconf} $(use_with perl bench)" 507 myconf="${myconf} $(use_with perl bench)"
401 myconf="${myconf} --enable-assembler" 508 myconf="${myconf} --enable-assembler"
402 myconf="${myconf} --with-extra-tools" 509 myconf="${myconf} --with-extra-tools"
403 myconf="${myconf} --with-innodb" 510 myconf="${myconf} --with-innodb"
404 myconf="${myconf} --without-readline" 511 myconf="${myconf} --without-readline"
512 myconf="${myconf} $(use_with ssl openssl)"
405 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)" 513 mysql_version_is_at_least "5.0" || myconf="${myconf} $(use_with raid)"
406 514
407 # --with-vio is not needed anymore, it's on by default and 515 # --with-vio is not needed anymore, it's on by default and
408 # has been removed from configure 516 # has been removed from configure
517 # Apply to 4.x and 5.0.[0-3]
409 if use ssl ; then 518 if use ssl ; then
410 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 519 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
411 fi
412
413 if mysql_version_is_at_least "5.1.11" ; then
414 myconf="${myconf} $(use_with ssl)"
415 else
416 myconf="${myconf} $(use_with ssl openssl)"
417 fi 520 fi
418 521
419 if mysql_version_is_at_least "5.0.60" ; then 522 if mysql_version_is_at_least "5.0.60" ; then
420 if use berkdb ; then 523 if use berkdb ; then
421 elog "Berkeley DB support was disabled due to build failures" 524 elog "Berkeley DB support was disabled due to build failures"
437 myconf="${myconf} --without-berkeley-db" 540 myconf="${myconf} --without-berkeley-db"
438 fi 541 fi
439 542
440 if mysql_version_is_at_least "4.1.3" ; then 543 if mysql_version_is_at_least "4.1.3" ; then
441 myconf="${myconf} --with-geometry" 544 myconf="${myconf} --with-geometry"
545 if [[ "${PN}" != "mysql-cluster" ]] ; then
442 myconf="${myconf} $(use_with cluster ndbcluster)" 546 myconf="${myconf} $(use_with cluster ndbcluster)"
547 fi
443 fi 548 fi
444 549
445 if mysql_version_is_at_least "4.1.3" && use extraengine ; then 550 if mysql_version_is_at_least "4.1.3" && use extraengine ; then
446 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html 551 # http://dev.mysql.com/doc/mysql/en/archive-storage-engine.html
447 myconf="${myconf} --with-archive-storage-engine" 552 myconf="${myconf} --with-archive-storage-engine"
478 583
479configure_51() { 584configure_51() {
480 # TODO: !!!! readd --without-readline 585 # TODO: !!!! readd --without-readline
481 # the failure depend upon config/ac-macros/readline.m4 checking into 586 # the failure depend upon config/ac-macros/readline.m4 checking into
482 # readline.h instead of history.h 587 # readline.h instead of history.h
483 myconf="${myconf} $(use_with ssl)" 588 myconf="${myconf} $(use_with ssl ssl /usr)"
484 myconf="${myconf} --enable-assembler" 589 myconf="${myconf} --enable-assembler"
485 myconf="${myconf} --with-geometry" 590 myconf="${myconf} --with-geometry"
486 myconf="${myconf} --with-readline" 591 myconf="${myconf} --with-readline"
487 myconf="${myconf} --with-row-based-replication"
488 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 592 myconf="${myconf} --with-zlib-dir=/usr/"
489 myconf="${myconf} --without-pstack" 593 myconf="${myconf} --without-pstack"
594 myconf="${myconf} --with-plugindir=/usr/$(get_libdir)/mysql/plugin"
595
596 # This is an explict die here, because if we just forcibly disable it, then the
597 # user's data is not accessible.
598 use max-idx-128 && die "Bug #336027: upstream has a corruption issue with max-idx-128 presently"
490 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 599 #use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
600 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
601 myconf="${myconf} $(use_enable community community-features)"
602 if use community; then
603 myconf="${myconf} $(use_enable profiling)"
604 else
605 myconf="${myconf} --disable-profiling"
606 fi
607 fi
608
609 # Scan for all available plugins
610 local plugins_avail="$(
611 LANG=C \
612 find "${S}" \
613 \( \
614 -name 'plug.in' \
615 -o -iname 'configure.in' \
616 -o -iname 'configure.ac' \
617 \) \
618 -print0 \
619 | xargs -0 sed -r -n \
620 -e '/^MYSQL_STORAGE_ENGINE/{
621 s~MYSQL_STORAGE_ENGINE\([[:space:]]*\[?([-_a-z0-9]+)\]?.*,~\1 ~g ;
622 s~^([^ ]+).*~\1~gp;
623 }' \
624 | tr -s '\n' ' '
625 )"
491 626
492 # 5.1 introduces a new way to manage storage engines (plugins) 627 # 5.1 introduces a new way to manage storage engines (plugins)
493 # like configuration=none 628 # like configuration=none
629 # This base set are required, and will always be statically built.
494 local plugins="csv,myisam,myisammrg,heap" 630 local plugins_sta="csv myisam myisammrg heap"
631 local plugins_dyn=""
632 local plugins_dis="example ibmdb2i"
633
634 # These aren't actually required by the base set, but are really useful:
635 plugins_sta="${plugins_sta} archive blackhole"
636
637 # default in 5.5.4
638 if mysql_version_is_at_least "5.5.4" ; then
639 plugins_sta="${plugins_sta} partition"
640 fi
641 # Now the extras
495 if use extraengine ; then 642 if use extraengine ; then
496 # like configuration=max-no-ndb, archive and example removed in 5.1.11 643 # like configuration=max-no-ndb, archive and example removed in 5.1.11
497 # not added yet: ibmdb2i 644 # not added yet: ibmdb2i
498 # Not supporting as examples: example,daemon_example,ftexample 645 # Not supporting as examples: example,daemon_example,ftexample
499 plugins="${plugins},archive,blackhole,federated,partition" 646 plugins_sta="${plugins_sta} partition"
500 647
648 if [[ "${PN}" != "mariadb" ]] ; then
501 elog "Before using the Federated storage engine, please be sure to read" 649 elog "Before using the Federated storage engine, please be sure to read"
502 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 650 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
651 plugins_dyn="${plugins_sta} federated"
652 else
653 elog "MariaDB includes the FederatedX engine. Be sure to read"
654 elog "http://askmonty.org/wiki/index.php/Manual:FederatedX_storage_engine"
655 plugins_dyn="${plugins_sta} federatedx"
656 fi
657 else
658 plugins_dis="${plugins_dis} partition federated"
503 fi 659 fi
504 660
505 # Upstream specifically requests that InnoDB always be built: 661 # Upstream specifically requests that InnoDB always be built:
506 # - innobase, innodb_plugin 662 # - innobase, innodb_plugin
507 # Build falcon if available for 6.x series. 663 # Build falcon if available for 6.x series.
508 for i in innobase innodb_plugin falcon ; do 664 for i in innobase falcon ; do
509 [ -e "${S}"/storage/${i} ] && plugins="${plugins},${i}" 665 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
510 done 666 done
667 for i in innodb_plugin ; do
668 [ -e "${S}"/storage/${i} ] && plugins_dyn="${plugins_dyn} ${i}"
669 done
511 670
512 # like configuration=max-no-ndb 671 # like configuration=max-no-ndb
513 if use cluster ; then 672 if ( use cluster || [[ "${PN}" == "mysql-cluster" ]] ) ; then
514 plugins="${plugins},ndbcluster" 673 plugins_sta="${plugins_sta} ndbcluster partition"
674 plugins_dis="${plugins_dis//partition}"
515 myconf="${myconf} --with-ndb-binlog" 675 myconf="${myconf} --with-ndb-binlog"
676 else
677 plugins_dis="${plugins_dis} ndbcluster"
678 fi
679
680 if [[ "${PN}" == "mariadb" ]] ; then
681 # In MariaDB, InnoDB is packaged in the xtradb directory, so it's not
682 # caught above.
683 # This is not optional, without it several upstream testcases fail.
684 # Also strongly recommended by upstream.
685 if [[ "${PV}" < "5.2.0" ]] ; then
686 myconf="${myconf} --with-maria-tmp-tables"
687 plugins_sta="${plugins_sta} maria"
688 else
689 myconf="${myconf} --with-aria-tmp-tables"
690 plugins_sta="${plugins_sta} aria"
516 fi 691 fi
517 692
693 [ -e "${S}"/storage/innobase ] || [ -e "${S}"/storage/xtradb ] ||
694 die "The ${P} package doesn't provide innobase nor xtradb"
695
696 for i in innobase xtradb ; do
697 [ -e "${S}"/storage/${i} ] && plugins_sta="${plugins_sta} ${i}"
698 done
699
700 myconf="${myconf} $(use_with libevent)"
701
702 if mysql_version_is_at_least "5.2" ; then
703 #This should include sphinx, but the 5.2.4 archive forgot the plug.in file
704 #for i in oqgraph sphinx ; do
705 for i in oqgraph ; do
706 use ${i} \
707 && plugins_dyn="${plugins_dyn} ${i}" \
708 || plugins_dis="${plugins_dis} ${i}"
709 done
710 fi
711 fi
712
713 if pbxt_available && [[ "${PBXT_NEWSTYLE}" == "1" ]]; then
714 use pbxt \
715 && plugins_dyn="${plugins_dyn} pbxt" \
716 || plugins_dis="${plugins_dis} pbxt"
717 fi
718
719 use static && \
720 plugins_sta="${plugins_sta} ${plugins_dyn}" && \
721 plugins_dyn=""
722
723 einfo "Available plugins: ${plugins_avail}"
724 einfo "Dynamic plugins: ${plugins_dyn}"
725 einfo "Static plugins: ${plugins_sta}"
726 einfo "Disabled plugins: ${plugins_dis}"
727
728 # These are the static plugins
518 myconf="${myconf} --with-plugins=${plugins}" 729 myconf="${myconf} --with-plugins=${plugins_sta// /,}"
730 # And the disabled ones
731 for i in ${plugins_dis} ; do
732 myconf="${myconf} --without-plugin-${i}"
733 done
519} 734}
520 735
521pbxt_src_configure() { 736pbxt_src_configure() {
522 mysql_init_vars 737 mysql_init_vars
523 738
524 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 739 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
525 740
526 einfo "Reconfiguring dir '${PWD}'" 741 einfo "Reconfiguring dir '${PWD}'"
527 AT_GNUCONF_UPDATE="yes" eautoreconf 742 eautoreconf
528 743
529 local myconf="" 744 local myconf=""
530 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}" 745 myconf="${myconf} --with-mysql=${S} --libdir=/usr/$(get_libdir)"
531 use debug && myconf="${myconf} --with-debug=full" 746 use debug && myconf="${myconf} --with-debug=full"
532 # TODO: is it safe/needed to use econf here ?
533 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 747 econf ${myconf} || die "Problem configuring PBXT storage engine"
534} 748}
535 749
536pbxt_src_compile() { 750pbxt_src_compile() {
751
537 # Be backwards compatible for now 752 # Be backwards compatible for now
538 if [[ $EAPI != 2 ]]; then 753 if [[ $EAPI != 2 ]]; then
539 pbxt_src_configure 754 pbxt_src_configure
540 fi 755 fi
541 # TODO: is it safe/needed to use emake here ? 756 # TODO: is it safe/needed to use emake here ?
545 # TODO: modify test suite for PBXT 760 # TODO: modify test suite for PBXT
546} 761}
547 762
548pbxt_src_install() { 763pbxt_src_install() {
549 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 764 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
550 make install || die "Failed to install PBXT" 765 emake install DESTDIR="${D}" || die "Failed to install PBXT"
551 popd 766 popd
552} 767}
553 768
554# 769#
555# EBUILD FUNCTIONS 770# EBUILD FUNCTIONS
560# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv" 775# die if FEATURES="test", USE="-minimal" and not using FEATURES="userpriv"
561# check for conflicting use flags 776# check for conflicting use flags
562# create new user and group for mysql 777# create new user and group for mysql
563# warn about deprecated features 778# warn about deprecated features
564mysql_pkg_setup() { 779mysql_pkg_setup() {
565 if hasq test ${FEATURES} ; then 780 if has test ${FEATURES} ; then
566 if ! use minimal ; then 781 if ! use minimal ; then
567 if [[ $UID -eq 0 ]]; then 782 if [[ $UID -eq 0 ]]; then
568 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root." 783 eerror "Testing with FEATURES=-userpriv is no longer supported by upstream. Tests MUST be run as non-root."
569 fi 784 fi
570 fi 785 fi
571 fi 786 fi
572 787
788 # bug 350844
789 case "${EAPI:-0}" in
790 0 | 1)
791 if use static && !built_with_use sys-libs/ncurses static-libs; then
792 die "To build MySQL statically you need to enable static-libs for sys-libs/ncurses"
793 fi
794 ;;
795 esac
796
573 # Check for USE flag problems in pkg_setup 797 # Check for USE flag problems in pkg_setup
574 if use static && use ssl ; then 798 if use static && use ssl ; then
575 eerror "MySQL does not support being built statically with SSL support enabled!"
576 die "MySQL does not support being built statically with SSL support enabled!" 799 M="MySQL does not support being built statically with SSL support enabled!"
800 eerror "${M}"
801 die "${M}"
802 fi
803
804 if mysql_version_is_at_least "5.1.51" \
805 && ! mysql_version_is_at_least "5.2" \
806 && use debug ; then
807 # Also in package.use.mask
808 die "Bug #344885: Upstream has broken USE=debug for 5.1 series >=5.1.51"
577 fi 809 fi
578 810
579 if ! mysql_version_is_at_least "5.0" \ 811 if ! mysql_version_is_at_least "5.0" \
580 && use raid \ 812 && use raid \
581 && use static ; then 813 && use static ; then
583 eerror "with RAID support enabled." 815 eerror "with RAID support enabled."
584 die "USE flags 'raid' and 'static' conflict!" 816 die "USE flags 'raid' and 'static' conflict!"
585 fi 817 fi
586 818
587 if mysql_version_is_at_least "4.1.3" \ 819 if mysql_version_is_at_least "4.1.3" \
588 && ( use cluster || use extraengine ) \ 820 && ( use cluster || use extraengine || use embedded ) \
589 && use minimal ; then 821 && use minimal ; then
590 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
591 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 822 M="USE flags 'cluster', 'extraengine', 'embedded' conflict with 'minimal' USE flag!"
823 eerror "${M}"
824 die "${M}"
592 fi 825 fi
593 826
594 # Bug #290570 fun. Upstream made us need a fairly new GCC4.
595 if mysql_version_is_at_least "5.0.83" ; then 827 if mysql_version_is_at_least "5.1" \
828 && xtradb_patch_available \
829 && use xtradb \
830 && use embedded ; then
831 M="USE flags 'xtradb' and 'embedded' conflict and cause build failures"
832 eerror "${M}"
833 die "${M}"
834 fi
835
836 # Bug #290570, 284946, 307251
837 # Upstream changes made us need a fairly new GCC4.
838 # But only for 5.0.8[3-6]!
839 if mysql_version_is_at_least "5.0.83" && ! mysql_version_is_at_least 5.0.87 ; then
596 GCC_VER=$(gcc-version) 840 GCC_VER=$(gcc-version)
597 case ${GCC_VER} in 841 case ${GCC_VER} in
598 2*|3*|4.0|4.1|4.2) die "Active GCC too old! Must have at least GCC4.3" ;; 842 2*|3*|4.0|4.1|4.2)
843 eerror "Some releases of MySQL required a very new GCC, and then"
844 eerror "later release relaxed that requirement again. Either pick a"
845 eerror "MySQL >=5.0.87, or use a newer GCC."
846 die "Active GCC too old!" ;;
599 esac 847 esac
600 fi 848 fi
601 849
602 # This should come after all of the die statements 850 # This should come after all of the die statements
603 enewgroup mysql 60 || die "problem adding 'mysql' group" 851 enewgroup mysql 60 || die "problem adding 'mysql' group"
604 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 852 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
605 853
606 mysql_check_version_range "4.0 to 5.0.99.99" \ 854 mysql_check_version_range "4.0 to 5.0.99.99" \
607 && use berkdb \ 855 && use berkdb \
608 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 856 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
857
858 if [ "${PN}" != "mysql-cluster" ] && use cluster; then
859 ewarn "Upstream has noted that the NDB cluster support in the 5.0 and"
860 ewarn "5.1 series should NOT be put into production. In the near"
861 ewarn "future, it will be disabled from building."
862 ewarn ""
863 ewarn "If you need NDB support, you should instead move to the new"
864 ewarn "mysql-cluster package that represents that upstream NDB"
865 ewarn "development."
866 fi
609} 867}
610 868
611# @FUNCTION: mysql_src_unpack 869# @FUNCTION: mysql_src_unpack
612# @DESCRIPTION: 870# @DESCRIPTION:
613# Unpack the source code and call mysql_src_prepare for EAPI < 2. 871# Unpack the source code and call mysql_src_prepare for EAPI < 2.
642 # Now link in right patches 900 # Now link in right patches
643 mysql_mv_patches 901 mysql_mv_patches
644 # And apply 902 # And apply
645 epatch 903 epatch
646 904
647 # Additional checks, remove bundled zlib 905 # last -fPIC fixup, per bug #305873
906 i="${S}"/storage/innodb_plugin/plug.in
907 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
908
909 # Additional checks, remove bundled zlib (Cluster needs this, for static
910 # memory management in zlib, leave available for Cluster)
911 if [[ "${PN}" != "mysql-cluster" ]] ; then
648 rm -f "${S}/zlib/"*.[ch] 912 rm -f "${S}/zlib/"*.[ch]
649 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 913 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
914 fi
650 rm -f "scripts/mysqlbug" 915 rm -f "scripts/mysqlbug"
651 916
652 # Make charsets install in the right place 917 # Make charsets install in the right place
653 find . -name 'Makefile.am' \ 918 find . -name 'Makefile.am' \
654 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \; 919 -exec sed --in-place -e 's!$(pkgdatadir)!'${MY_SHAREDSTATEDIR}'!g' {} \;
664 rm -f "scripts/mysqlbug" 929 rm -f "scripts/mysqlbug"
665 fi 930 fi
666 931
667 local rebuilddirlist d 932 local rebuilddirlist d
668 933
669 if mysql_version_is_at_least "5.1.26" && use xtradb ; then 934 if xtradb_patch_available && use xtradb ; then
670 einfo "Replacing InnoDB with Percona XtraDB" 935 einfo "Adding storage engine: Percona XtraDB (replacing InnoDB)"
671 pushd "${S}"/storage 936 pushd "${S}"/storage >/dev/null
672 i="innobase" 937 i="innobase"
673 o="${WORKDIR}/storage-${i}.mysql-upstream" 938 o="${WORKDIR}/storage-${i}.mysql-upstream"
674 # Have we been here already? 939 # Have we been here already?
675 [ -h "${i}" ] && rm -f "${i}" 940 [ -d "${o}" ] && rm -f "${i}"
676 # Or maybe we haven't 941 # Or maybe we haven't
677 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 942 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
678 ln -s "${WORKDIR}/${XTRADB_P}" "${i}" 943 cp -ral "${WORKDIR}/${XTRADB_P}" "${i}"
679 popd 944 popd >/dev/null
945 fi
946
947 if pbxt_patch_available && [[ "${PBXT_NEWSTYLE}" == "1" ]] && use pbxt ; then
948 einfo "Adding storage engine: PBXT"
949 pushd "${S}"/storage >/dev/null
950 i='pbxt'
951 [ -d "${i}" ] && rm -rf "${i}"
952 cp -ral "${WORKDIR}/${PBXT_P}" "${i}"
953 popd >/dev/null
680 fi 954 fi
681 955
682 if mysql_version_is_at_least "5.1.12" ; then 956 if mysql_version_is_at_least "5.1.12" ; then
683 einfo "Updating innobase cmake"
684 rebuilddirlist="." 957 rebuilddirlist="."
958 # This does not seem to be needed presently. robbat2 2010/02/23
959 #einfo "Updating innobase cmake"
685 # TODO: check this with a cmake expert 960 ## TODO: check this with a cmake expert
686 cmake \ 961 #cmake \
687 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 962 # -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
688 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \ 963 # -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
689 "storage/innobase" 964 # "storage/innobase"
690 else 965 else
691 rebuilddirlist=". innobase" 966 rebuilddirlist=". innobase"
692 fi 967 fi
693 968
694 for d in ${rebuilddirlist} ; do 969 for d in ${rebuilddirlist} ; do
695 einfo "Reconfiguring dir '${d}'" 970 einfo "Reconfiguring dir '${d}'"
696 pushd "${d}" &>/dev/null 971 pushd "${d}" &>/dev/null
697 AT_GNUCONF_UPDATE="yes" eautoreconf 972 eautoreconf
698 popd &>/dev/null 973 popd &>/dev/null
699 done 974 done
700 975
701 if mysql_check_version_range "4.1 to 5.0.99.99" \ 976 if mysql_check_version_range "4.1 to 5.0.99.99" \
702 && use berkdb ; then 977 && use berkdb ; then
758 export CXXFLAGS 1033 export CXXFLAGS
759 1034
760 # bug #283926, with GCC4.4, this is required to get correct behavior. 1035 # bug #283926, with GCC4.4, this is required to get correct behavior.
761 append-flags -fno-strict-aliasing 1036 append-flags -fno-strict-aliasing
762 1037
1038 # bug #335185, #335995, with >= GCC4.3.3 on x86 only, omit-frame-pointer
1039 # causes a mis-compile.
1040 # Upstream bugs:
1041 # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=38562
1042 # http://bugs.mysql.com/bug.php?id=45205
1043 use x86 && version_is_at_least "4.3.3" "$(gcc-fullversion)" && \
1044 append-flags -fno-omit-frame-pointer && \
1045 filter-flags -fomit-frame-pointer
1046
763 econf \ 1047 econf \
764 --libexecdir="/usr/sbin" \ 1048 --libexecdir="/usr/sbin" \
765 --sysconfdir="${MY_SYSCONFDIR}" \ 1049 --sysconfdir="${MY_SYSCONFDIR}" \
766 --localstatedir="${MY_LOCALSTATEDIR}" \ 1050 --localstatedir="${MY_LOCALSTATEDIR}" \
767 --sharedstatedir="${MY_SHAREDSTATEDIR}" \ 1051 --sharedstatedir="${MY_SHAREDSTATEDIR}" \
770 --with-low-memory \ 1054 --with-low-memory \
771 --with-client-ldflags=-lstdc++ \ 1055 --with-client-ldflags=-lstdc++ \
772 --enable-thread-safe-client \ 1056 --enable-thread-safe-client \
773 --with-comment="Gentoo Linux ${PF}" \ 1057 --with-comment="Gentoo Linux ${PF}" \
774 --without-docs \ 1058 --without-docs \
1059 --with-LIBDIR="$(get_libdir)" \
775 ${myconf} || die "econf failed" 1060 ${myconf} || die "econf failed"
776 1061
777 # TODO: Move this before autoreconf !!! 1062 # TODO: Move this before autoreconf !!!
778 find . -type f -name Makefile -print0 \ 1063 find . -type f -name Makefile -print0 \
779 | xargs -0 -n100 sed -i \ 1064 | xargs -0 -n100 sed -i \
780 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 1065 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
781 1066
782 if [[ $EAPI == 2 ]]; then 1067 if [[ $EAPI == 2 ]] && [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
783 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure 1068 pbxt_patch_available && use pbxt && pbxt_src_configure
784 fi 1069 fi
785} 1070}
786 1071
787# @FUNCTION: mysql_src_compile 1072# @FUNCTION: mysql_src_compile
788# @DESCRIPTION: 1073# @DESCRIPTION:
789# Compile the mysql code. 1074# Compile the mysql code.
790mysql_src_compile() { 1075mysql_src_compile() {
791 # Be backwards compatible for now 1076 # Be backwards compatible for now
792 case ${EAPI:-0} in 1077 case ${EAPI:-0} in
793 2) : ;; 1078 2) : ;;
794 0 | 1) mysql_src_configure ;; 1079 0 | 1) mysql_src_configure ;;
795 esac 1080 esac
796 1081
797 emake || die "emake failed" 1082 emake || die "emake failed"
798 1083
799 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile 1084 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1085 pbxt_patch_available && use pbxt && pbxt_src_compile
1086 fi
800} 1087}
801 1088
802# @FUNCTION: mysql_src_install 1089# @FUNCTION: mysql_src_install
803# @DESCRIPTION: 1090# @DESCRIPTION:
804# Install mysql. 1091# Install mysql.
805mysql_src_install() { 1092mysql_src_install() {
806 # Make sure the vars are correctly initialized 1093 # Make sure the vars are correctly initialized
807 mysql_init_vars 1094 mysql_init_vars
808 1095
809 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 1096 emake install \
1097 DESTDIR="${D}" \
1098 benchdir_root="${MY_SHAREDSTATEDIR}" \
1099 testroot="${MY_SHAREDSTATEDIR}" \
1100 || die "emake install failed"
810 1101
811 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install 1102 if [[ "${PBXT_NEWSTYLE}" != "1" ]]; then
1103 pbxt_patch_available && use pbxt && pbxt_src_install
1104 fi
812 1105
813 # Convenience links 1106 # Convenience links
814 einfo "Making Convenience links for mysqlcheck multi-call binary" 1107 einfo "Making Convenience links for mysqlcheck multi-call binary"
815 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 1108 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
816 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 1109 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
820 einfo "Removing duplicate /usr/share/mysql files" 1113 einfo "Removing duplicate /usr/share/mysql files"
821 rm -Rf "${D}/usr/share/info" 1114 rm -Rf "${D}/usr/share/info"
822 for removeme in "mysql-log-rotate" mysql.server* \ 1115 for removeme in "mysql-log-rotate" mysql.server* \
823 binary-configure* my-*.cnf mi_test_all* 1116 binary-configure* my-*.cnf mi_test_all*
824 do 1117 do
825 rm -f "${D}"/usr/share/mysql/${removeme} 1118 rm -f "${D}"/${MY_SHAREDSTATEDIR}/${removeme}
826 done 1119 done
827 1120
828 # Clean up stuff for a minimal build 1121 # Clean up stuff for a minimal build
829 if use minimal ; then 1122 if use minimal ; then
830 einfo "Remove all extra content for minimal build" 1123 einfo "Remove all extra content for minimal build"
832 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 1125 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
833 rm -f "${D}/usr/sbin/mysqld" 1126 rm -f "${D}/usr/sbin/mysqld"
834 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 1127 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
835 fi 1128 fi
836 1129
1130 # Unless they explicitly specific USE=test, then do not install the
1131 # testsuite. It DOES have a use to be installed, esp. when you want to do a
1132 # validation of your database configuration after tuning it.
1133 if use !test ; then
1134 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
1135 fi
1136
837 # Configuration stuff 1137 # Configuration stuff
838 if mysql_version_is_at_least "4.1" ; then 1138 case ${MYSQL_PV_MAJOR} in
839 mysql_mycnf_version="4.1"
840 else
841 mysql_mycnf_version="4.0" 1139 3*|4.0) mysql_mycnf_version="4.0" ;;
842 fi 1140 4.[1-9]|5.0) mysql_mycnf_version="4.1" ;;
843 einfo "Building default my.cnf" 1141 5.[1-9]|6*|7*) mysql_mycnf_version="5.1" ;;
1142 esac
1143 einfo "Building default my.cnf (${mysql_mycnf_version})"
844 insinto "${MY_SYSCONFDIR}" 1144 insinto "${MY_SYSCONFDIR}"
845 doins scripts/mysqlaccess.conf 1145 doins scripts/mysqlaccess.conf
1146 mycnf_src="my.cnf-${mysql_mycnf_version}"
846 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \ 1147 sed -e "s!@DATADIR@!${MY_DATADIR}!g" \
847 "${FILESDIR}/my.cnf-${mysql_mycnf_version}" \ 1148 "${FILESDIR}/${mycnf_src}" \
848 > "${TMPDIR}/my.cnf.ok" 1149 > "${TMPDIR}/my.cnf.ok"
849 if mysql_version_is_at_least "4.1" && use latin1 ; then 1150 if use latin1 ; then
850 sed -e "s|utf8|latin1|g" -i "${TMPDIR}/my.cnf.ok" 1151 sed -i \
1152 -e "/character-set/s|utf8|latin1|g" \
1153 "${TMPDIR}/my.cnf.ok"
851 fi 1154 fi
852 newins "${TMPDIR}/my.cnf.ok" my.cnf 1155 newins "${TMPDIR}/my.cnf.ok" my.cnf
853 1156
854 # Minimal builds don't have the MySQL server 1157 # Minimal builds don't have the MySQL server
855 if ! use minimal ; then 1158 if ! use minimal ; then
870 done 1173 done
871 fi 1174 fi
872 1175
873 # Docs 1176 # Docs
874 einfo "Installing docs" 1177 einfo "Installing docs"
875 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 1178 for i in README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE ; do
1179 [[ -f "$i" ]] && dodoc "$i"
1180 done
876 doinfo "${S}"/Docs/mysql.info 1181 doinfo "${S}"/Docs/mysql.info
877 1182
878 # Minimal builds don't have the MySQL server 1183 # Minimal builds don't have the MySQL server
879 if ! use minimal ; then 1184 if ! use minimal ; then
880 einfo "Including support files and sample configurations" 1185 einfo "Including support files and sample configurations"
882 for script in \ 1187 for script in \
883 "${S}"/support-files/my-*.cnf \ 1188 "${S}"/support-files/my-*.cnf \
884 "${S}"/support-files/magic \ 1189 "${S}"/support-files/magic \
885 "${S}"/support-files/ndb-config-2-node.ini 1190 "${S}"/support-files/ndb-config-2-node.ini
886 do 1191 do
887 dodoc "${script}" 1192 [[ -f "$script" ]] && dodoc "${script}"
888 done 1193 done
889 1194
890 docinto "scripts" 1195 docinto "scripts"
891 for script in "${S}"/scripts/mysql* ; do 1196 for script in "${S}"/scripts/mysql* ; do
892 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1197 [[ -f "$script" ]] && [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
893 done 1198 done
894 1199
895 fi 1200 fi
896 1201
897 mysql_lib_symlinks "${D}" 1202 mysql_lib_symlinks "${D}"
931 for script in \ 1236 for script in \
932 support-files/my-*.cnf \ 1237 support-files/my-*.cnf \
933 support-files/magic \ 1238 support-files/magic \
934 support-files/ndb-config-2-node.ini 1239 support-files/ndb-config-2-node.ini
935 do 1240 do
1241 [[ -f "${script}" ]] \
936 dodoc "${script}" 1242 && dodoc "${script}"
937 done 1243 done
938 1244
939 docinto "scripts" 1245 docinto "scripts"
940 for script in scripts/mysql* ; do 1246 for script in scripts/mysql* ; do
1247 [[ -f "${script}" ]] \
941 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 1248 && [[ "${script%.sh}" == "${script}" ]] \
1249 && dodoc "${script}"
942 done 1250 done
943 1251
944 einfo 1252 einfo
945 elog "You might want to run:" 1253 elog "You might want to run:"
946 elog "\"emerge --config =${CATEGORY}/${PF}\"" 1254 elog "\"emerge --config =${CATEGORY}/${PF}\""
947 elog "if this is a new install." 1255 elog "if this is a new install."
948 einfo 1256 einfo
949 fi
950 1257
951 if mysql_version_is_at_least "5.1.12" && use pbxt ; then 1258 einfo
1259 elog "If you are upgrading major versions, you should run the"
1260 elog "mysql_upgrade tool."
1261 einfo
1262 fi
1263
1264 if pbxt_available && use pbxt ; then
952 # TODO: explain it better 1265 # TODO: explain it better
953 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 1266 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
954 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 1267 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
955 elog "if, after that, you cannot start the MySQL server," 1268 elog "if, after that, you cannot start the MySQL server,"
956 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 1269 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"
1007 fi 1320 fi
1008 fi 1321 fi
1009 1322
1010 local pwd1="a" 1323 local pwd1="a"
1011 local pwd2="b" 1324 local pwd2="b"
1012 local maxtry=5 1325 local maxtry=15
1326
1327 if [ -z "${MYSQL_ROOT_PASSWORD}" -a -f "${ROOT}/root/.my.cnf" ]; then
1328 MYSQL_ROOT_PASSWORD="$(sed -n -e '/^password=/s,^password=,,gp' "${ROOT}/root/.my.cnf")"
1329 fi
1013 1330
1014 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then 1331 if [[ -d "${ROOT}/${MY_DATADIR}/mysql" ]] ; then
1015 ewarn "You have already a MySQL database in place." 1332 ewarn "You have already a MySQL database in place."
1016 ewarn "(${ROOT}/${MY_DATADIR}/*)" 1333 ewarn "(${ROOT}/${MY_DATADIR}/*)"
1017 ewarn "Please rename or delete it if you wish to replace it." 1334 ewarn "Please rename or delete it if you wish to replace it."
1020 1337
1021 # Bug #213475 - MySQL _will_ object strenously if your machine is named 1338 # Bug #213475 - MySQL _will_ object strenously if your machine is named
1022 # localhost. Also causes weird failures. 1339 # localhost. Also causes weird failures.
1023 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost" 1340 [[ "${HOSTNAME}" == "localhost" ]] && die "Your machine must NOT be named localhost"
1024 1341
1025 einfo "Creating the mysql database and setting proper" 1342 if [ -z "${MYSQL_ROOT_PASSWORD}" ]; then
1026 einfo "permissions on it ..."
1027 1343
1028 einfo "Insert a password for the mysql 'root' user" 1344 einfo "Please provide a password for the mysql 'root' user now, in the"
1345 einfo "MYSQL_ROOT_PASSWORD env var or through the /root/.my.cnf file."
1029 ewarn "Avoid [\"'\\_%] characters in the password" 1346 ewarn "Avoid [\"'\\_%] characters in the password"
1030 read -rsp " >" pwd1 ; echo 1347 read -rsp " >" pwd1 ; echo
1031 1348
1032 einfo "Retype the password" 1349 einfo "Retype the password"
1033 read -rsp " >" pwd2 ; echo 1350 read -rsp " >" pwd2 ; echo
1034 1351
1035 if [[ "x$pwd1" != "x$pwd2" ]] ; then 1352 if [[ "x$pwd1" != "x$pwd2" ]] ; then
1036 die "Passwords are not the same" 1353 die "Passwords are not the same"
1354 fi
1355 MYSQL_ROOT_PASSWORD="${pwd1}"
1356 unset pwd1 pwd2
1037 fi 1357 fi
1038 1358
1039 local options="" 1359 local options=""
1040 local sqltmp="$(emktemp)" 1360 local sqltmp="$(emktemp)"
1041 1361
1055 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \ 1375 [[ -f "${ROOT}/${MY_DATADIR}/mysql/user.frm" ]] \
1056 || die "MySQL databases not installed" 1376 || die "MySQL databases not installed"
1057 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null 1377 chown -R mysql:mysql "${ROOT}/${MY_DATADIR}" 2>/dev/null
1058 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null 1378 chmod 0750 "${ROOT}/${MY_DATADIR}" 2>/dev/null
1059 1379
1380 # Figure out which options we need to disable to do the setup
1381 helpfile="${TMPDIR}/mysqld-help"
1382 ${ROOT}/usr/sbin/mysqld --verbose --help >"${helpfile}" 2>/dev/null
1383 for opt in grant-tables host-cache name-resolve networking slave-start bdb \
1384 federated innodb ssl log-bin relay-log slow-query-log external-locking \
1385 ndbcluster \
1386 ; do
1387 optexp="--(skip-)?${opt}" optfull="--skip-${opt}"
1388 egrep -sq -- "${optexp}" "${helpfile}" && options="${options} ${optfull}"
1389 done
1390 # But some options changed names
1391 egrep -sq external-locking "${helpfile}" && \
1392 options="${options/skip-locking/skip-external-locking}"
1393
1060 if mysql_version_is_at_least "4.1.3" ; then 1394 if mysql_version_is_at_least "4.1.3" ; then
1061 options="--skip-ndbcluster"
1062
1063 # Filling timezones, see 1395 # Filling timezones, see
1064 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html 1396 # http://dev.mysql.com/doc/mysql/en/time-zone-support.html
1065 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null 1397 "${ROOT}/usr/bin/mysql_tzinfo_to_sql" "${ROOT}/usr/share/zoneinfo" > "${sqltmp}" 2>/dev/null
1066 1398
1067 if [[ -r "${help_tables}" ]] ; then 1399 if [[ -r "${help_tables}" ]] ; then
1068 cat "${help_tables}" >> "${sqltmp}" 1400 cat "${help_tables}" >> "${sqltmp}"
1069 fi 1401 fi
1070 fi 1402 fi
1403
1404 einfo "Creating the mysql database and setting proper"
1405 einfo "permissions on it ..."
1071 1406
1072 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock" 1407 local socket="${ROOT}/var/run/mysqld/mysqld${RANDOM}.sock"
1073 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid" 1408 local pidfile="${ROOT}/var/run/mysqld/mysqld${RANDOM}.pid"
1074 local mysqld="${ROOT}/usr/sbin/mysqld \ 1409 local mysqld="${ROOT}/usr/sbin/mysqld \
1075 ${options} \ 1410 ${options} \
1076 --user=mysql \ 1411 --user=mysql \
1077 --skip-grant-tables \
1078 --basedir=${ROOT}/usr \ 1412 --basedir=${ROOT}/usr \
1079 --datadir=${ROOT}/${MY_DATADIR} \ 1413 --datadir=${ROOT}/${MY_DATADIR} \
1080 --skip-innodb \
1081 --skip-bdb \
1082 --skip-networking \
1083 --max_allowed_packet=8M \ 1414 --max_allowed_packet=8M \
1084 --net_buffer_length=16K \ 1415 --net_buffer_length=16K \
1416 --default-storage-engine=MyISAM \
1085 --socket=${socket} \ 1417 --socket=${socket} \
1086 --pid-file=${pidfile}" 1418 --pid-file=${pidfile}"
1419 #einfo "About to start mysqld: ${mysqld}"
1420 ebegin "Starting mysqld"
1087 ${mysqld} & 1421 ${mysqld} &
1422 rc=$?
1088 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do 1423 while ! [[ -S "${socket}" || "${maxtry}" -lt 1 ]] ; do
1089 maxtry=$((${maxtry}-1)) 1424 maxtry=$((${maxtry}-1))
1090 echo -n "." 1425 echo -n "."
1091 sleep 1 1426 sleep 1
1092 done 1427 done
1428 eend $rc
1093 1429
1430 if ! [[ -S "${socket}" ]]; then
1431 die "Completely failed to start up mysqld with: ${mysqld}"
1432 fi
1433
1434 ebegin "Setting root password"
1094 # Do this from memory, as we don't want clear text passwords in temp files 1435 # Do this from memory, as we don't want clear text passwords in temp files
1095 local sql="UPDATE mysql.user SET Password = PASSWORD('${pwd1}') WHERE USER='root'" 1436 local sql="UPDATE mysql.user SET Password = PASSWORD('${MYSQL_ROOT_PASSWORD}') WHERE USER='root'"
1096 "${ROOT}/usr/bin/mysql" \ 1437 "${ROOT}/usr/bin/mysql" \
1097 --socket=${socket} \ 1438 --socket=${socket} \
1098 -hlocalhost \ 1439 -hlocalhost \
1099 -e "${sql}" 1440 -e "${sql}"
1441 eend $?
1100 1442
1101 einfo "Loading \"zoneinfo\", this step may require a few seconds ..." 1443 ebegin "Loading \"zoneinfo\", this step may require a few seconds ..."
1102
1103 "${ROOT}/usr/bin/mysql" \ 1444 "${ROOT}/usr/bin/mysql" \
1104 --socket=${socket} \ 1445 --socket=${socket} \
1105 -hlocalhost \ 1446 -hlocalhost \
1106 -uroot \ 1447 -uroot \
1107 -p"${pwd1}" \ 1448 -p"${MYSQL_ROOT_PASSWORD}" \
1108 mysql < "${sqltmp}" 1449 mysql < "${sqltmp}"
1450 rc=$?
1451 eend $?
1452 [ $rc -ne 0 ] && ewarn "Failed to load zoneinfo!"
1109 1453
1110 # Stop the server and cleanup 1454 # Stop the server and cleanup
1455 einfo "Stopping the server ..."
1111 kill $(< "${pidfile}" ) 1456 kill $(< "${pidfile}" )
1112 rm -f "${sqltmp}" 1457 rm -f "${sqltmp}"
1113 einfo "Stopping the server ..."
1114 wait %1 1458 wait %1
1115 einfo "Done" 1459 einfo "Done"
1116} 1460}
1117 1461
1118# @FUNCTION: mysql_pkg_postrm 1462# @FUNCTION: mysql_pkg_postrm

Legend:
Removed from v.1.132  
changed lines
  Added in v.1.165

  ViewVC Help
Powered by ViewVC 1.1.20